"""Robot based on requests and concurrent.futures,
processes multiple URLs in parallel (multiprocess).

This file is a part of Bookmarks database and Internet robot.

"""

__author__ = "Oleg Broytman <phd@phdru.name>"
__copyright__ = "Copyright (C) 2024 PhiloSoft Design"
__license__ = "GNU GPL"

__all__ = ['robot_multirequests']


import concurrent.futures

from Robots.concurrent_futures import concurrent_futures
from robots import import_robot, set_params, robot_params


class robot_multirequests(concurrent_futures):
    def __init__(self, *args, **kw):
        self.concurrent_class = concurrent.futures.ProcessPoolExecutor
        concurrent_futures.__init__(self, *args, **kw)

    def check_bkmk_task(self):
        return check_bookmark_subproc


def check_bookmark_subproc(bookmark):
    log_lines = []
    robot = import_robot('requests')
    set_params(robot, robot_params)
    robot.report_checked = False
    robot(log_lines.append).check_bookmark(bookmark)
    return bookmark, log_lines
